/* 

OpenStarLogo

Originally developed by Mitchel Resnick, Andrew Begel, Eric Klopfer, Michael
Bolin, Corey McCaffrey, Molly Jones, Matthew Notowidigdo, Sebastian Ortiz, David
Greenspan, Michael Mandel, Tim Garnett, Max Goldman, Julie Kane, Russell
Zahniser, Weifang Sun, and Robert Tau at the MIT Teacher Education Program and
Media Laboratory, MIT, Cambridge, Massachusetts, with support from the National
Science Foundation and the LEGO Group. With previous work by Vanessa Colella,
Bill Thies, Brian Silverman, Monica Linden, Alice Yang, Ankur Mehta, Adam Eames,
Max Planck, and Sumita Kumar.

Copyright (c) 2006 MIT Teacher Education Program

Created by the MIT Teacher Education Program (http://education.mit.edu), and MIT
Media Lab (http://www.media.mit.edu) at the Massachusetts Institute of
Technology, Cambridge, MA. Permission is hereby granted, free of charge, to any
person obtaining a copy of this software and associated documentation files (the
"Software"), to deal in the Software without restriction, including without
limitation the rights to use, copy, modify, merge, publish, distribute,
sublicense, and/or sell copies of the Software, and to permit persons to whom
the Software is furnished to do so, subject to the following conditions:

1. The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software. 2. For rights to publish,
distribute, sublicense or sell the Software or its derivatives for commercial
purposes, please see the Technology Licensing Office, MIT, Five Cambridge
Center, Kendall Square Room NE25-230, Cambridge, MA 02142-1493, (617) 253-6966

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

--------------------------
@Copyright (c) 1997-1999 The Regents of the University of California.
All rights reserved.

Permission is hereby granted, without written agreement and without
license or royalty fees, to use, copy, modify, and distribute this
software and its documentation for any purpose, provided that the
above copyright notice and the following two paragraphs appear in all
copies of this software.

IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY
FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES
ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF
THE UNIVERSITY OF CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.

THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE SOFTWARE
PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF
CALIFORNIA HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS.

                                                PT_COPYRIGHT_VERSION_2
                                                COPYRIGHTENDKEY
@ProposedRating Yellow (cxh@eecs.berkeley.edu)
@AcceptedRating Yellow (cxh@eecs.berkeley.edu)
*/
package ptolemy;

import java.awt.*;
import java.io.*;
import java.util.*;
import starlogo.LineWidget;
import starlogo.StarLogo;
import starlogo.*;

public class HistoLive extends Histogram {

    int n;
    double val;
    LineWidget lw;
    int type;
    int num;
    private Application app;

    //Vector data;
    public double time = 0;
    
    public HistoLive(Application app, LineWidget lw, int type) {
	super();
	this.lw = lw;
	this.app = app;
	this.type = type;
	this.num = 10;
	initme();
	//data = new Vector();
	//[10];
	//for (int i=0; i<10; i++)
	//    data[i] = new Vector();
	//	System.out.println("created new histogram object...");
    }

    public PlotBox copy(Application app, LineWidget l) {
	HistoLive hl = new HistoLive(app, l, type);
	super.copy(l, hl);
	hl.n = n;
	hl.val = val;
	hl.num = num;
	hl.time = time;
	return hl;
    }

    public void allOff() {
	setGrid(false);
	setTitle("", lw.tbc.getPreTitle());
	setXLabel("");
	setYLabel("");
    }

    public Object clone() {
	try {
	    return super.clone();
	}
	catch (CloneNotSupportedException c) {
	    c.printStackTrace(); return "False";
	}
    }

    public void initme() {
	//	setupLineWidget(lw);
	//	System.out.println("initialized lw");
	if (StarLogo.DEBUG) {  System.out.println("initialized lw");  }
	setGrid(false);
    }

    /**
    public synchronized void addDataPoint(int n, double val) {
	if (type == LineWidget.LINE) {
	    addPoint(n, time / num, val, true);
	    time++;
	}
	if (type == LineWidget.BAR)
	    addPoint(1, n, val, false);
	repaint();
    }

    public synchronized void addDataPoint(int n, double x, double y) {
	addPoint(n, x, y, true);
	repaint();
    }
    **/

    public synchronized void addDataPointToHash(int dataset, int key, double y, int num) {
	this.addHashPoint(dataset, key, y, num);
	//super.repaint();
    }

    /////////////////////////////////////////
    public Hashtable hashtable = new Hashtable();

    public synchronized void addHashPoint(int dataset, int key, double y, int num) {
	_checkDatasetIndex(dataset);
	Integer datasetInt = new Integer(dataset);
	Double yDouble = new Double(y);
	Hashtable temp = null;
	if (hashtable.get(datasetInt) == null) {
	    temp = new Hashtable();
	    temp.put(new Integer(key), yDouble);
	    hashtable.put(datasetInt, temp);
	}
	else {
	    Integer keyInt = new Integer(key);
	    temp = (Hashtable)hashtable.get(datasetInt);
	    if (temp.get(keyInt) != null) {
		Double dTemp = (Double)temp.get(keyInt);
		//System.out.println("erasing point: " + dTemp.doubleValue());
		this.erasePoint(dataset, dTemp.doubleValue());

		///////////////////////
		// Calculate the bin number.
		int bin = (int)(Math.round((dTemp.doubleValue()-_binOffset)/_binWidth));
		Integer binobj = new Integer(bin);

		// Add to the appropriate bin
		Hashtable bins = (Hashtable)_histogram.elementAt(dataset);
		int count;
		if (bins.containsKey(binobj)) {
		    // decrease the count
		    count = ((Integer)bins.get(binobj)).intValue() - 1;
		    if (count < 0) {
			count = 0;
//			System.out.println("///////");
			//System.out.println("** resetting count.");
			//System.out.println("** binobj: " + binobj.intValue());
			//System.out.println("** dTemp: " + dTemp);
			//System.out.println("** binOffset: " + _binOffset);
			//System.out.println("** binWidth: " + _binWidth);
//			System.out.println("///////");
		    }
		    bins.put(binobj, new Integer(count));
		} else {
		    //throw new RuntimeException("invariant failed.");
		    //System.out.println("invariant failed.  dTemp: "  +
				       //dTemp.doubleValue() +
				       //" y: " +
				       //y);
		}
		//////////////////////

	    }
	    temp.put(new Integer(key), yDouble);
	}
	//	System.out.println("adding... y: " + y);
	addPoint(dataset, y, num);

	if ((_xTop - _xBottom) / _binWidth > 10.00) {
	    hashtable.put(datasetInt, new Hashtable());
	    _points.setElementAt(new Vector(), dataset);
	    _histogram.setElementAt(new Hashtable(), dataset);
	    //System.out.println("recalculating...");
	    _binWidth = (int)(Math.round((_xTop - _xBottom) / 5.0));
	    //	    _binOffset = _binWidth / 2.0;

	    for(Enumeration keys = temp.keys(); keys.hasMoreElements();) {
	    	Integer tempKeyInt = (Integer)keys.nextElement();
		Double tempValDouble = ((Double)temp.get(tempKeyInt));
		this.addHashPoint(dataset,
				  tempKeyInt.intValue(),
				  tempValDouble.doubleValue(),
				  num);
	    }//end while
	}
    }

    public synchronized void setBinWidth(int dataset, double width) {
	Integer datasetInt = new Integer(dataset);
	Hashtable temp = (Hashtable)hashtable.get(datasetInt);
	hashtable.put(datasetInt, new Hashtable());
	_points.setElementAt(new Vector(), dataset);
	_histogram.setElementAt(new Hashtable(), dataset);
	//System.out.println("recalculating...");
	_binWidth = width;
	//	_binOffset = _binWidth / 2.0;

	for(Enumeration keys = temp.keys(); keys.hasMoreElements();) {
	    Integer tempKeyInt = (Integer)keys.nextElement();
	    Double tempValDouble = ((Double)temp.get(tempKeyInt));
	    this.addHashPoint(dataset,
			      tempKeyInt.intValue(),
			      tempValDouble.doubleValue(),
			      num);
	}//end while
    }

    public synchronized void removeHashPoint(int key) {
	//	System.out.println("who: " + key);
	for(Enumeration keys = hashtable.keys(); keys.hasMoreElements();) {
		Integer nextInt = (Integer)keys.nextElement();
	    if (hashtable.get(nextInt) != null) {
		Hashtable temp = (Hashtable)hashtable.get(nextInt);
		Integer keyInt = new Integer(key);
		if (temp.get(keyInt) != null) {
		    double y = ((Double)temp.get(keyInt)).doubleValue();
		    //System.out.println(">> y: " + y);
		    erasePoint(nextInt.intValue(), y);

		    ///////////////////////
		    // Calculate the bin number.
		    int bin = (int)(Math.round((y-_binOffset)/_binWidth));
		    Integer binobj = new Integer(bin);

		    // Add to the appropriate bin
		    Hashtable bins = (Hashtable)_histogram.elementAt(nextInt.intValue());
		    int count;
		    if (bins.containsKey(binobj)) {
			// decrease the count
			count = ((Integer)bins.get(binobj)).intValue() - 1;
			if (count < 0) {
                //System.out.println("resetting count.");
                count = 0;
            }
			bins.put(binobj, new Integer(count));
		    } else {
			//		    throw new RuntimeException("invariant failed.");
			//System.out.println("invariant failed.  y: "  + y);
		    }
		    //////////////////////
		    temp.remove(keyInt);
		}
	    }
	}
    }

    public synchronized void erasePoint(int dataset, double y) {
	double temp;
    Vector pointsVector;
    try {
	    pointsVector = (Vector)_points.elementAt(dataset);
    } catch (ArrayIndexOutOfBoundsException aioobe) {
        return;
    }
	for (int i=0; i<pointsVector.size(); i++) {
	    temp = ((Double)pointsVector.elementAt(i)).doubleValue();
	    if (temp == y) {
		pointsVector.removeElementAt(i);
		return;
	    }
	}
	//System.out.println("ERROR: bad arguments to erasePoint(int, double, double)");
    }

    /////////////////////////////////////////

/**
    public synchronized void addDataPointToVector(int n, double y, int count) {
	Vector v = new Vector();
	v.addElement(new Integer(n));
	v.addElement(new Double(y));
	data.addElement(v);
	if (data.size() >= (num * count)) {
	    //System.out.println("clearing...: " + count);
	    clear(false); //clear datasets before repainting
	    for (int i=0; i<data.size(); i++) {
		v = (Vector)data.elementAt(i);
		addPoint(((Integer)v.elementAt(0)).intValue(),
			 ((Double)v.elementAt(1)).doubleValue()
			 );
	    }
	    repaint();
	    lw.parent.repaint(lw.position);
	    data = new Vector();
	}
    }//end sync function
**/
    public void setNum(int num) {
	this.num = num;
    }
    public int getNum() {
	return this.num;
    }

}
