/******************************************************************
OpenStarLogo

Originally developed by Mitchel Resnick, Andrew Begel, Eric Klopfer, Michael
Bolin, Corey McCaffrey, Molly Jones, Matthew Notowidigdo, Sebastian Ortiz, David
Greenspan, Michael Mandel, Tim Garnett, Max Goldman, Julie Kane, Russell
Zahniser, Weifang Sun, and Robert Tau at the MIT Teacher Education Program and
Media Laboratory, MIT, Cambridge, Massachusetts, with support from the National
Science Foundation and the LEGO Group. With previous work by Vanessa Colella,
Bill Thies, Brian Silverman, Monica Linden, Alice Yang, Ankur Mehta, Adam Eames,
Max Planck, and Sumita Kumar.

Copyright (c) 2006 MIT Teacher Education Program

Created by the MIT Teacher Education Program (http://education.mit.edu), and MIT
Media Lab (http://www.media.mit.edu) at the Massachusetts Institute of
Technology, Cambridge, MA. Permission is hereby granted, free of charge, to any
person obtaining a copy of this software and associated documentation files (the
"Software"), to deal in the Software without restriction, including without
limitation the rights to use, copy, modify, merge, publish, distribute,
sublicense, and/or sell copies of the Software, and to permit persons to whom
the Software is furnished to do so, subject to the following conditions:

1. The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software. 2. For rights to publish,
distribute, sublicense or sell the Software or its derivatives for commercial
purposes, please see the Technology Licensing Office, MIT, Five Cambridge
Center, Kendall Square Room NE25-230, Cambridge, MA 02142-1493, (617) 253-6966

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.


 *******************************************************************/

package starlogo;

import java.lang.Math;
import java.awt.event.*;
import java.awt.*;
//import java.net.*;
//import java.util.Arrays;
//import yoyo.*;

public class ColorSquare extends Panel {

    //public static HueColorStruct[] sortedByHues = null;

    public static final int gridWidth = 23;
    public static final int gridHeight = 6;

    public static final int cellWidth = 8;
    public static final int cellHeight = 8;

    public int colorDown = 0;
    public int shadeDown = 5;
    public int curcolor = 5;
    public boolean update = true;


    public ColorSquare() {
		  super();
/**
      sortedByHues = new HueColorStruct[Colors.numcolors];
      float tempHue;
      Color tempColor;
      for (int i = 0; i<Colors.numcolors; i++) {
        tempColor = Colors.colorarray[32 * i];
        tempHue = Color.RGBtoHSB(tempColor.getRed(),
                                 tempColor.getGreen(),
                                 tempColor.getBlue(),
                                 null)[0];
        sortedByHues[i] = new HueColorStruct(tempColor, tempHue, i);        
      }
      Arrays.sort(sortedByHues);//, 0, Colors.numcolors);
      **/
		  setSize(gridWidth * cellWidth, gridHeight * cellHeight);
	  }

	public Dimension getPreferredSize() {
		return new Dimension(gridWidth * cellWidth, gridHeight * cellHeight);
	}

  public void paint(Graphics g) {
  	for (int i = 0; i < gridWidth; i++) {
	  	for (int j = 0; j< gridHeight; j++) {	      
  	    g.setColor(Colors.colorarray[i + gridWidth*j]);
	      g.fillRect(i*cellWidth, j*cellHeight, (i+1)*cellWidth, (j+1)*cellHeight);
		  }
	  }
  	g.setColor(Color.black);
	  //g.drawRect(0,0,getBounds().width, getBounds().height);
  }

}



