/******************************************************************
OpenStarLogo

Originally developed by Mitchel Resnick, Andrew Begel, Eric Klopfer, Michael
Bolin, Corey McCaffrey, Molly Jones, Matthew Notowidigdo, Sebastian Ortiz, David
Greenspan, Michael Mandel, Tim Garnett, Max Goldman, Julie Kane, Russell
Zahniser, Weifang Sun, and Robert Tau at the MIT Teacher Education Program and
Media Laboratory, MIT, Cambridge, Massachusetts, with support from the National
Science Foundation and the LEGO Group. With previous work by Vanessa Colella,
Bill Thies, Brian Silverman, Monica Linden, Alice Yang, Ankur Mehta, Adam Eames,
Max Planck, and Sumita Kumar.

Copyright (c) 2006 MIT Teacher Education Program

Created by the MIT Teacher Education Program (http://education.mit.edu), and MIT
Media Lab (http://www.media.mit.edu) at the Massachusetts Institute of
Technology, Cambridge, MA. Permission is hereby granted, free of charge, to any
person obtaining a copy of this software and associated documentation files (the
"Software"), to deal in the Software without restriction, including without
limitation the rights to use, copy, modify, merge, publish, distribute,
sublicense, and/or sell copies of the Software, and to permit persons to whom
the Software is furnished to do so, subject to the following conditions:

1. The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software. 2. For rights to publish,
distribute, sublicense or sell the Software or its derivatives for commercial
purposes, please see the Technology Licensing Office, MIT, Five Cambridge
Center, Kendall Square Room NE25-230, Cambridge, MA 02142-1493, (617) 253-6966

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.


 *******************************************************************/

package starlogo;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import yoyo.*;
abstract class JWidgetDialog extends JSLDialog implements WidgetDialog {
	
    protected Application app;

    public boolean ok;
    
    public boolean pressedOK() {
	return ok;
    }
    
    protected JButton bok, bca; 
    
    protected JWidgetDialog(Frame parent, Application app, String title) {
	super(parent, title, true);
	this.app = app;
	bok = new JButton(app.textBundle.getString("ok_label"));
        bca = new JButton(app.textBundle.getString("cancel_label"));
    }

    protected JWidgetDialog(Frame parent, Application app, String title, boolean resizable) {
	super(parent, title, true, resizable);
	this.app = app;
	bok = new JButton(app.textBundle.getString("ok_label"));
        bca = new JButton(app.textBundle.getString("cancel_label"));
    }

    protected void init() {
	setupComponents();
	setupGBC();
	setupPosition();
	
	initOKCancel(bok, bca);
	initShortcuts();
	//System.out.println("finished w/ JWidgetDialog constructor");
    }
    
    // inherit these
    
    protected void ok() {
	if (valid_inputs()) {
	    ok = true;
	    super.ok();
	}
    }
    
    protected void cancel() {
	ok = false;
	super.cancel();
    }
    
    // implement these
    
    public abstract void getValues(WidgetDrag wd);
    
    protected abstract void setupComponents();
    protected abstract void setupGBC();
    protected abstract void setupPosition();
    protected abstract boolean valid_inputs();
    //protected abstract boolean setModality(boolean value);
}




