/********************************************************************
OpenStarLogo

Originally developed by Mitchel Resnick, Andrew Begel, Eric Klopfer, Michael
Bolin, Corey McCaffrey, Molly Jones, Matthew Notowidigdo, Sebastian Ortiz, David
Greenspan, Michael Mandel, Tim Garnett, Max Goldman, Julie Kane, Russell
Zahniser, Weifang Sun, and Robert Tau at the MIT Teacher Education Program and
Media Laboratory, MIT, Cambridge, Massachusetts, with support from the National
Science Foundation and the LEGO Group. With previous work by Vanessa Colella,
Bill Thies, Brian Silverman, Monica Linden, Alice Yang, Ankur Mehta, Adam Eames,
Max Planck, and Sumita Kumar.

Copyright (c) 2006 MIT Teacher Education Program

Created by the MIT Teacher Education Program (http://education.mit.edu), and MIT
Media Lab (http://www.media.mit.edu) at the Massachusetts Institute of
Technology, Cambridge, MA. Permission is hereby granted, free of charge, to any
person obtaining a copy of this software and associated documentation files (the
"Software"), to deal in the Software without restriction, including without
limitation the rights to use, copy, modify, merge, publish, distribute,
sublicense, and/or sell copies of the Software, and to permit persons to whom
the Software is furnished to do so, subject to the following conditions:

1. The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software. 2. For rights to publish,
distribute, sublicense or sell the Software or its derivatives for commercial
purposes, please see the Technology Licensing Office, MIT, Five Cambridge
Center, Kendall Square Room NE25-230, Cambridge, MA 02142-1493, (617) 253-6966

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *******************************************************************/
 package yoyo;

import java.util.*;

public class PrimList implements YoYoMethods {
	
    public String[] methodList() {
	ResourceBundle rb = PrimStartup.getYoYoCommandsBundle();
	String[] output = {
	    rb.getString("primlist_list"), "prim_list",
	    rb.getString("primlist_make_list"), "prim_makelist",
	    rb.getString("primlist_sentence"), "prim_sentence",
	    rb.getString("primlist_se"), "prim_sentence",
	    rb.getString("primlist_fput"), "prim_fput",
	    rb.getString("primlist_lput"), "prim_lput",
	    rb.getString("primlist_butfirst"), "prim_butfirst",
	    rb.getString("primlist_bf"), "prim_butfirst",
	    rb.getString("primlist_butlast"), "prim_butlast",
	    rb.getString("primlist_bl"), "prim_butlast",
	    rb.getString("primlist_first"), "prim_first",
	    rb.getString("primlist_last"), "prim_last",
	    rb.getString("primlist_item"), "prim_item",
	    rb.getString("primlist_pick"), "prim_random_item",
	    rb.getString("primlist_setitem"), "prim_setitem",
	    rb.getString("primlist_insert"), "prim_insert",
	    rb.getString("primlist_remove"), "prim_remove",
	    rb.getString("primlist_remove_element"), "prim_removeele",
	    rb.getString("primlist_nth"), "prim_nth",
	    rb.getString("primlist_setnth"), "prim_setnth",
	    rb.getString("primlist_length"), "prim_length",
	    rb.getString("primlist_word"), "prim_word",
	    rb.getString("primlist_position"), "prim_position",
	    rb.getString("primlist_memberp"), "prim_memberp",
	    rb.getString("primlist_emptyp"), "prim_emptyp",
	    rb.getString("primlist_listp"), "prim_listp",
	    rb.getString("primlist_stringp"), "prim_wordp",	
	    rb.getString("primlist_substring"), "prim_substring",
	    rb.getString("primlist_sublist"), "prim_sublist",
	    rb.getString("primlist_copy_list"), "prim_copylist",
	    rb.getString("primlist_string_to_list"), "prim_wordtolist",
	    rb.getString("primlist_list_to_string"), "prim_listtoword",
	    rb.getString("primlist_sort_num_list"), "prim_sortnumlist",
	    rb.getString("primlist_min_of_list"), "prim_listmin",
	    rb.getString("primlist_max_of_list"), "prim_listmax",
	    rb.getString("primlist_median_of_list"), "prim_listmedian",
	    rb.getString("primlist_average_of_list"), "prim_listmean",
	    rb.getString("primlist_variance_of_list"), "prim_listvariance",
	    rb.getString("primlist_sdev_of_list"), "prim_listsdev",
	    rb.getString("primlist_mode_of_list"), "prim_listmode",
	    rb.getString("primlist_sum_of_list"), "prim_listsum",
	    rb.getString("primlist_dolist"), "prim_dolist",
	    rb.getString("primlist_to_list"), "prim_to_list",
	    rb.getString("primlist_replace"), "prim_replace",
	    rb.getString("primlist_starts_with"), "prim_startswith",
	    rb.getString("primlist_ends_with"), "prim_endswith",
	    rb.getString("primlist_starts_with_ignore_case"), "prim_startswithnocase",
	    rb.getString("primlist_ends_with_ignore_case"), "prim_endswithnocase",
	    rb.getString("primlist_equals_ignore_case"), "prim_equalsnocase",
	    rb.getString("primlist_trim"), "prim_trim",
	    rb.getString("primlist_reverse"), "prim_reverse",
	};
	return output;
    }
	
    public String[] infixList() { return null; }

    public void prePrimCall(Primitive p, Object[] arglist, Context c) {}
    public void postPrimCall(Primitive p, Context c) {}
	
    public static Object prim_list(Object v0, Object v1, Context c)  {
	Object[] output = { v0, v1 };
	return output;
    }
	
    public static Object prim_makelist(Object v0, Object v1, Context c) {
	int length = YoYo.aInteger(c, v0);
	Object[] output = new Object[length];
	for(int i = 0; i < length; i++) {
	    output[i] = v1;
	}
	return output;
    }
		
	
    public static Object prim_sentence(Object v0, Object v1, Context c)  {		
		
	if (v0 instanceof Object[]) {
	    int v0length = ((Object[])v0).length;
	    if (v1 instanceof Object[]) {
		int v1length = ((Object[])v1).length;
		Object[] output = new Object[v0length + v1length];
		System.arraycopy((Object[])v0, 0, output, 0, v0length);
		System.arraycopy((Object[])v1, 0, output, v0length, v1length);
		return output;
	    }
	    Object[] output = new Object[v0length + 1];
	    System.arraycopy((Object[])v0, 0, output, 0, v0length);
	    output[v0length] = v1;
	    return output;
	}
	if (v1 instanceof Object[]) {
	    int v1length = ((Object[])v1).length;
	    Object[] output = new Object[v1length + 1];
	    System.arraycopy((Object[])v1, 0, output, 1, v1length);
	    output[0] = v0;
	    return output;
	}
	Object[] output = { v0, v1 };
	return output;
    }
	
    public static Object prim_fput(Object v0, Object v1, Context c)  {
	if (v1 instanceof Object[]) {
	    Object[] output = new Object[((Object[])v1).length+1];
	    System.arraycopy((Object[])v1, 0, output, 1, output.length-1);
	    output[0] = v0;
	    return output;
	}
	else if (v1 instanceof Symbol || v1 instanceof String) {
	    String first = YoYo.aString(c, v0);
	    String second = YoYo.aString(c, v1);
	    return first + second;
	}
	LogoError.error(YoYo.printToString(v0) + " " + LogoError.ANDOR + 
			" " + YoYo.printToString(v1) 
			+ LogoError.NOT_LIST_OR_STRING, c);
	return null;
    }
	
    public static Object prim_lput(Object v0, Object v1, Context c)  {
	if (v1 instanceof Object[]) {
	    Object[] output = new Object[((Object[])v1).length+1];
	    System.arraycopy((Object[])v1, 0, output, 0, output.length-1);
	    output[output.length-1] = v0;
	    return output;
	}
	else if (v1 instanceof Symbol || v1 instanceof String) {
	    String first = YoYo.aString(c, v0);
	    String second = YoYo.aString(c, v1);
	    return first + second;
	}
	LogoError.error(YoYo.printToString(v0) + " " + LogoError.ANDOR + " " + 
			YoYo.printToString(v1) + LogoError.NOT_LIST_OR_STRING, c);
	return null; 
    }
	
    public static Object prim_butfirst(Object v0, Context c)  {
	if (v0 instanceof Object[]) {
	    if (((Object[])v0).length == 0) 
		LogoError.error(LogoError.CANTTAKE + " " + LogoError.BF + " " +
				LogoError.OFEMPTYLIST, c);
	    Object[] output = new Object[((Object[])v0).length-1];
	    System.arraycopy((Object[])v0, 1, output, 0, output.length);
	    return output;
	}
	else if (v0 instanceof String || v0 instanceof Symbol) {
	    String first = YoYo.aString(c, v0);
	    if (first.length() == 0) 
		LogoError.error(LogoError.CANTTAKE + " " + LogoError.BF + " " +
				LogoError.OFEMPTYSTRING, c);
	    return first.substring(1);
	}	
	LogoError.error(YoYo.printToString(v0) + LogoError.NOT_LIST_OR_STRING, c);
	return null; 
    }
	
    public static Object prim_butlast(Object v0, Context c)  {
	if (v0 instanceof Object[]) {
	    if (((Object[])v0).length == 0) 
		LogoError.error(LogoError.CANTTAKE + " " + LogoError.BL + " " +
				LogoError.OFEMPTYLIST, c);
	    Object[] output = new Object[((Object[])v0).length-1];
	    System.arraycopy((Object[])v0, 0, output, 0, output.length);
	    return output;
	}
	else if (v0 instanceof String || v0 instanceof Symbol) {
	    String first = YoYo.aString(c, v0);
	    if (first.length() == 0) 
		LogoError.error(LogoError.CANTTAKE + " " + LogoError.BL + " " +
				LogoError.OFEMPTYSTRING, c);
	    return first.substring(0, first.length() - 1);
	}	
	LogoError.error(YoYo.printToString(v0) + LogoError.NOT_LIST_OR_STRING, c);
	return null; 
    }
	
    public static Object prim_first(Object v0, Context c)  {
	if (v0 instanceof Object[]) {
	    try {
		return ((Object[])v0)[0];
	    }
	    catch(ArrayIndexOutOfBoundsException e) {
		if (((Object[])v0).length == 0)	
		LogoError.error(LogoError.CANTTAKE + " " + LogoError.FIRST + " " +
				LogoError.OFEMPTYLIST, c);
	    }
	}
	else if (v0 instanceof String || v0 instanceof Symbol) {
	    String first = YoYo.aString(c, v0);
	    try {
		return String.valueOf(first.charAt(0));
	    }
	    catch(StringIndexOutOfBoundsException e) {
		if (first.length() == 0) 
		    LogoError.error(LogoError.CANTTAKE + " " + LogoError.FIRST + " " +
				    LogoError.OFEMPTYSTRING, c);
	    }
	}
	LogoError.error(YoYo.printToString(v0) + LogoError.NOT_LIST_OR_STRING, c);
	return null;
    }
	
    public static Object prim_last(Object v0, Context c)  {
	if (v0 instanceof Object[]) {
	    try {
		return ((Object[])v0)[((Object[])v0).length-1];
	    }
	    catch(ArrayIndexOutOfBoundsException e) {
		if (((Object[])v0).length == 0)	
		LogoError.error(LogoError.CANTTAKE + " " + LogoError.LAST + " " +
				LogoError.OFEMPTYLIST, c);
	    }
	}
	else if (v0 instanceof String || v0 instanceof Symbol) {
	    String first = YoYo.aString(c, v0);
	    try {
		return String.valueOf(first.charAt(first.length()-1));
	    }
	    catch(StringIndexOutOfBoundsException e) {
		if (first.length() == 0) 
		    LogoError.error(LogoError.CANTTAKE + " " + LogoError.LAST + " " +
				    LogoError.OFEMPTYSTRING, c);
	    }
	}
	LogoError.error(YoYo.printToString(v0) + LogoError.NOT_LIST_OR_STRING, c);
	return null;
    }
	
    public static Object prim_random_item(Object v0, Context c) {
	if (v0 instanceof Object[]) {
	    if (((Object[])v0).length == 0) 
		LogoError.error(LogoError.CANTPICK + " " + LogoError.ELEMENT + " " + 
				LogoError.FROMEMPTYLIST, c);
	    int index = (int)Math.floor(PrimMath.random.nextDouble() * ((Object[])v0).length);
	    return ((Object[])v0)[index];
	}
	else if (v0 instanceof String || v0 instanceof Symbol) {
	    String first = YoYo.aString(c, v0);
	    if (first.length() == 0) {
		LogoError.error(LogoError.CANTPICK + " " + LogoError.CHARACTER + " " +
				LogoError.FROMEMPTYSTRING, c);
	    }
	    int index = (int)Math.floor(PrimMath.random.nextDouble() * first.length());
	    return String.valueOf(first.charAt(index));
	}
	LogoError.error(YoYo.printToString(v0) + LogoError.NOT_LIST_OR_STRING, c);
	return null;
    }

    public static Object prim_item(Object v0, Object v1, Context c)  {
	if (v1 instanceof Object[]) {
	    int index = YoYo.aInteger(c, v0);
	    try {
		return ((Object[])v1)[index-1];
	    }
	    catch(ArrayIndexOutOfBoundsException e) {
		if (index < 1) 
		    LogoError.error(LogoError.INDEX + " " + index + " " +
				    LogoError.INDEXTOOLOW, c);
		if (index > ((Object[])v1).length) 
		    LogoError.error(LogoError.INDEX + " " + index + " " +
				    LogoError.INDEXTOOHIGH, c);
	    }
	}
	else if (v1 instanceof String || v1 instanceof Symbol) {
	    String first = YoYo.aString(c, v1);
	    int index = YoYo.aInteger(c, v0);
	    try {
		return String.valueOf(first.charAt(index-1));
	    }
	    catch(StringIndexOutOfBoundsException e) {
		if (index < 1) 
		    LogoError.error(LogoError.INDEX + " " + index + " " +
				    LogoError.INDEXTOOLOW, c);
		if (index > first.length()) 
		    LogoError.error(LogoError.INDEX + " " + index + " " +
				    LogoError.INDEXTOOHIGH, c);
	    }
	}
	LogoError.error(YoYo.printToString(v1) + LogoError.NOT_LIST_OR_STRING, c);
	return null;
    }
	
    public static void prim_setitem(Object v0, Object v1, Object v2, Context c)  {
	if (v1 instanceof Object[]) {
	    int index = YoYo.aInteger(c, v0);
	    try {
		synchronized (v1) {
		    ((Object[])v1)[index-1] = v2;
		}
	    }
	    catch (ArrayIndexOutOfBoundsException e) {
		if (index < 1) 
		    LogoError.error(LogoError.INDEX + " " + index + " " +
				    LogoError.INDEXTOOLOW, c);
		if (index > ((Object[])v1).length) 
		    LogoError.error(LogoError.INDEX + " " + index + " " +
				    LogoError.INDEXTOOHIGH, c);
	    }
	    return;
	}
	LogoError.error(YoYo.printToString(v1) + LogoError.NOT_LIST, c);
	return;
    }
	
    public static Object prim_insert(Object v0, Object v1, Object v2, Context c) {
	if (v1 instanceof Object[]) {
	    Object[] src = (Object[])v1;
	    int index = YoYo.aInteger(c, v0);
	    Object[] list = new Object[src.length+1];
	    try {
		System.arraycopy(src,0,list,0,index-1);
		list[index-1] = v2;
		System.arraycopy(src,index-1,list,index,src.length-index+1); 
	    } catch (IndexOutOfBoundsException e) {
		if (index < 1) 
		    LogoError.error(LogoError.INDEX + " " + index + " " +
				    LogoError.INDEXTOOLOW, c);
		if (index > src.length) 
		    LogoError.error(LogoError.INDEX + " " + index + " " +
				    LogoError.INDEXTOOHIGH, c);
	    }
	    return list;
	}		
	LogoError.error(YoYo.printToString(v1)+ LogoError.NOT_LIST, c);
	return null;
    }
	
    public static Object prim_remove(Object v0, Object v1, Context c) {
	if (v1 instanceof Object[]) {
	    Object[] src = (Object[])v1;
	    int index = YoYo.aInteger(c, v0);
	    Object[] list = new Object[src.length-1];
	    try {
		System.arraycopy(src,0,list,0,index-1);
		System.arraycopy(src,index,list,index-1,src.length-index);
	    } catch (IndexOutOfBoundsException e) {
		if (index < 1) 
		    LogoError.error(LogoError.INDEX + " " + index + " " +
				    LogoError.INDEXTOOLOW, c);
		if (index > src.length) 
		    LogoError.error(LogoError.INDEX + " " + index + " " +
				    LogoError.INDEXTOOHIGH, c);
	    }
	    return list;
	}
	LogoError.error(YoYo.printToString(v1)+ LogoError.NOT_LIST, c);
	return null;
    }
	
    public static Object prim_removeele(Object v0, Object v1, Context c)  {
	if (v1 instanceof Object[]) {
	    Object[] src = (Object[])v1;
	    Object[] list = new Object[src.length];
	    int j = 0;
	    for (int i=0; i< src.length; i++) {
		if (YoYo.equal(src[i], v0) == YoYo.symfalse)
		    list[j++] = src[i];
	    }
	    Object[] output = new Object[j];
	    System.arraycopy(list,0,output,0,j);
	    return output;
	}
	LogoError.error(YoYo.printToString(v1) + LogoError.NOT_LIST, c);
	return null;
    }
	
    public static Object prim_nth(Object v0, Object v1, Context c)  {
	if (v1 instanceof Object[]) {
	    int index = YoYo.aInteger(c, v0);
	    try {
		return ((Object[])v1)[index];
	    }
	    catch(ArrayIndexOutOfBoundsException e) {
		if (index < 0) 
		    LogoError.error(LogoError.INDEX + " " + index + " " +
				    LogoError.INDEXTOOLOW, c);
		if (index >= ((Object[])v1).length) 
		    LogoError.error(LogoError.INDEX + " " + index + " " +
				    LogoError.INDEXTOOHIGH, c);
	    }
	}
	else if (v1 instanceof String || v1 instanceof Symbol) {
	    String first = YoYo.aString(c, v1);
	    int index = YoYo.aInteger(c, v0);
	    try {
		return String.valueOf(first.charAt(index));
	    }
	    catch(StringIndexOutOfBoundsException e) {
		if (index < 0) 
		    LogoError.error(LogoError.INDEX + " " + index + " " +
				    LogoError.INDEXTOOLOW, c);
		if (index >= first.length()) 
		    LogoError.error(LogoError.INDEX + " " + index + " " +
				    LogoError.INDEXTOOHIGH, c);
	    }
	}
	LogoError.error(YoYo.printToString(v1) + LogoError.NOT_LIST_OR_STRING, c);
	return null;
    }
	
    public static void prim_setnth(Object v0, Object v1, Object v2, Context c)  {
	if (v1 instanceof Object[]) {
	    int index = YoYo.aInteger(c, v0);
	    try {
		synchronized(v1) {
		    ((Object[])v1)[index] = v2;
		}
	    }
	    catch(ArrayIndexOutOfBoundsException e) {
		if (index < 0) 
		    LogoError.error(LogoError.INDEX + " " + index + " " +
				    LogoError.INDEXTOOLOW, c);
		if (index >= ((Object[])v1).length) 
		    LogoError.error(LogoError.INDEX + " " + index + " " +
				    LogoError.INDEXTOOHIGH, c);
	    }
	    return;
	}
	LogoError.error(YoYo.printToString(v1) + LogoError.NOT_LIST, c);
	return;
    }
	
    public static Object prim_length(Object v0, Context c)  {
	if (v0 instanceof Object[]) {
	    return new Integer(((Object[])v0).length);
	}
	else if (v0 instanceof String || v0 instanceof Symbol) {
	    return new Integer(YoYo.aString(c, v0).length());
	}
	LogoError.error(YoYo.printToString(v0) + LogoError.NOT_LIST_OR_STRING, c);
	return null;
    }
	
    public static Object prim_startswith(Object v0, Object v1, Context c) {
	String s = YoYo.aString(c, v0);
	String begin = YoYo.aString(c, v1);
	if (s.startsWith(begin)) return YoYo.symtrue; else return YoYo.symfalse;
    }
	
    public static Object prim_endswith(Object v0, Object v1, Context c) {
	String s = YoYo.aString(c, v0);
	String end = YoYo.aString(c, v1);
	if (s.endsWith(end)) return YoYo.symtrue; else return YoYo.symfalse;
    }
	
    public static Object prim_startswithnocase(Object v0, Object v1, Context c) {
	String s = YoYo.aString(c, v0);
	String begin = YoYo.aString(c, v1);
	if (s.toLowerCase().startsWith(begin.toLowerCase())) 
	    return YoYo.symtrue; else return YoYo.symfalse;
    }
	
    public static Object prim_endswithnocase(Object v0, Object v1, Context c) {
	String s = YoYo.aString(c, v0);
	String end = YoYo.aString(c, v1);
	if (s.toLowerCase().endsWith(end.toLowerCase())) 
	    return YoYo.symtrue; else return YoYo.symfalse;
    }
	
    public static Object prim_equalsnocase(Object v0, Object v1, Context c) {
	String s = YoYo.aString(c, v0);
	String end = YoYo.aString(c, v1);
	if (s.toLowerCase().equals(end.toLowerCase())) 
	    return YoYo.symtrue; else return YoYo.symfalse;
    }	
	
    public static Object prim_trim(Object v0, Context c) {
	String s = YoYo.aString(c, v0);
	return s.trim();
    }

    public static Object prim_word(Object v0, Object v1, Context c)  {
	return YoYo.printToString(v0) + YoYo.printToString(v1);
    }
	
    public static Object prim_position(Object v0, Object v1, Context c)  {
	if (v1 instanceof Object[]) {
	    Object[] list = (Object[])v1;
	    int i = 0;
	    while(i < list.length) {
		if (YoYo.equal(list[i], v0) == YoYo.symtrue) 
		    return new Integer(i+1);
		i++;
	    }
	    return YoYo.symfalse;
	}
	else if (v1 instanceof String || v1 instanceof Symbol) {
	    String foo = YoYo.aString(c, v1);
	    int pos = foo.indexOf(YoYo.aString(c, v0));
	    if (pos >= 0) return new Integer(pos);
	    return YoYo.symfalse;
	}
	LogoError.error(YoYo.printToString(v0) + LogoError.NOT_LIST_OR_STRING, c);
	return null;
    }
	
    public static Object prim_memberp(Object v0, Object v1, Context c)  {
	if (v1 instanceof Object[]) {
	    Object[] list = (Object[])v1;
	    int i = 0;
	    while(i < list.length) {
		if (YoYo.equal(list[i], v0) == YoYo.symtrue) 
		    return YoYo.symtrue;
		i++;
	    }
	    return YoYo.symfalse;
	}
	else if (v1 instanceof String || v1 instanceof Symbol) {
	    String foo = YoYo.aString(c, v1);
	    int pos = foo.indexOf(YoYo.aString(c, v0));
	    if (pos >= 0) return YoYo.symtrue;
	    return YoYo.symfalse;
	}
	LogoError.error(YoYo.printToString(v1) + LogoError.NOT_LIST_OR_STRING, c);
	return null;
    }
	
    public static Object prim_listp(Object v0, Context c)  {
	if (v0 instanceof Object[]) return YoYo.symtrue;
	return YoYo.symfalse;
    }
	
    public static Object prim_emptyp(Object v0, Context c)  {
	if (v0 instanceof Object[]) {
	    if (((Object[])v0).length == 0)	return YoYo.symtrue;
	    return YoYo.symfalse;
	}
	else if (v0 instanceof String || v0 instanceof Symbol) {
	    if (YoYo.aString(c, v0).length() == 0) return YoYo.symtrue;
	    return YoYo.symfalse;
	}
	else return YoYo.symfalse;
    }
	
    public static Object prim_wordp(Object v0, Context c)  {
	if (v0 instanceof String || v0 instanceof Symbol || v0 instanceof Number)
	    return YoYo.symtrue;
	else return YoYo.symfalse;
    }
	
    public static Object prim_sublist(Object v0, Object v1, Object v2, Context c) {
	Object[] foo = YoYo.aList(c, v0);
	int begin = YoYo.aInteger(c, v1);
	int end = YoYo.aInteger(c, v2);
	try {
	    Object[] out = new Object[end - begin + 1];
	    System.arraycopy(foo, begin-1, out, 0, out.length);
	    return out;
	}
	catch (IndexOutOfBoundsException e) {
	    if (begin <= 0) LogoError.error(LogoError.STARTINGINDEX + " " + begin + 
					    " " + LogoError.INDEXTOOLOW, c);
	    if (begin >= foo.length) LogoError.error(LogoError.STARTINGINDEX + " " + begin + 
					    " " + LogoError.INDEXTOOHIGH, c);
	    if (end <= 0) LogoError.error(LogoError.ENDINGINDEX + " " + end + 
					    " " + LogoError.INDEXTOOLOW, c);
	    if (end >= foo.length) LogoError.error(LogoError.ENDINGINDEX + " " + end + 
					    " " + LogoError.INDEXTOOHIGH, c);
	    if (begin > end) 
		LogoError.error(LogoError.STARTINGINDEX + " " + begin + " " +
				LogoError.ISGREATERTHAN + " " + LogoError.ENDINGINDEX +
				" " + end, c);
	}
	return null;
    }

    public static Object prim_substring(Object v0, Object v1, Object v2, Context c)  {
	String foo = YoYo.aString(c, v0);
	int begin = YoYo.aInteger(c, v1);
	int end = YoYo.aInteger(c, v2);
	try {
	    return foo.substring(begin, end);
	}
	catch (StringIndexOutOfBoundsException e) {
	    if (begin < 0) LogoError.error(LogoError.STARTINGINDEX + " " + begin + 
					    " " + LogoError.INDEXTOOLOW, c);
	    if (begin > foo.length()) LogoError.error(LogoError.STARTINGINDEX + " " + begin + 
					    " " + LogoError.INDEXTOOHIGH, c);
	    if (end < 0) LogoError.error(LogoError.ENDINGINDEX + " " + end + 
					    " " + LogoError.INDEXTOOLOW, c);
	    if (end > foo.length()) LogoError.error(LogoError.ENDINGINDEX + " " + end + 
					    " " + LogoError.INDEXTOOHIGH, c);
	    if (begin > end) 
		LogoError.error(LogoError.STARTINGINDEX + " " + begin + " " +
				LogoError.ISGREATERTHAN + " " + LogoError.ENDINGINDEX +
				" " + end, c);
	    if (begin > end) 
		LogoError.error("starting index: " + begin + " is greater than ending index: " + end, c);
	}
	return null;
    }
	
	
    public static Object prim_listtoword(Object v0, Context c)  {
	return YoYo.printToString(YoYo.aList(c, v0));
    }
	
    public static Object prim_wordtolist(Object v0, Context c)  {
	return Reader.read(YoYo.aString(c, v0));
    }

    public static Object prim_sortnumlist(Object v0, Context c) {
	Object[] list0 = YoYo.aList(c, v0);
	if ((list0.length == 0) || (list0 == null)) return v0;
	double[] list1 = new double[list0.length];
	for (int i=0; i<list1.length; i++)
	    list1[i] = YoYo.aDouble(c, list0[i]);
	list1 = mergesort(list1, 0, list1.length-1);
	Double[] list2 = new Double[list1.length];
	for (int i=0; i<list2.length; i++)
	    list2[i] = new Double(list1[i]);
	return list2;
    }
	
    public static Object prim_listmin(Object v0, Context c) {
	Object[] list = YoYo.aList(c, v0);
	double min = Double.MAX_VALUE;
	for (int i = 0; i<list.length; i++) {
	    if (list[i] instanceof Number) {
		double val = YoYo.aDoubleNoWarn(c, list[i]);
		if (val < min) min = val;
	    }
	}
	return new Double(min);
    }
	
    public static Object prim_listmax(Object v0, Context c) {
	Object[] list = YoYo.aList(c, v0);
	double max = -Double.MAX_VALUE;
	for (int i = 0; i<list.length; i++) {
	    if (list[i] instanceof Number) {
		double val = YoYo.aDoubleNoWarn(c, list[i]);
		if (val > max) max = val;
	    }
	}
	return new Double(max);
    }
	
    public static Object prim_listmedian(Object v0, Context c) {
	Object[] list0 = YoYo.aList(c, v0);
	if (list0.length == 0) {
	    LogoError.error(LogoError.CANTCOMPUTE + " " + LogoError.MEDIAN + " " +
			    LogoError.OFEMPTYLIST, c);
	    return null;
	}
	int count  = 0;
	for(int i =0; i < list0.length; i++) {
	    if (list0[i] instanceof Number) count++;
	}
	if (count == 0) {
	    LogoError.error(LogoError.CANTCOMPUTE + " " + LogoError.MEDIAN + " " +
			    LogoError.OFLIST + " " + YoYo.printToString(v0) + " " +
			    LogoError.HASNONUMBERS, c);
	}
	double[] list1 = new double[count];
	for (int i=0; i<list1.length; i++) {
	    if (list0[i] instanceof Number) {
		list1[--count] = YoYo.aDoubleNoWarn(c, list0[i]);
	    }
	}
	// crappy implementation, use 6.046 to make it run in linear time instead of n lg n
	list1 = mergesort(list1, 0, list1.length-1);
	if (0 == (list1.length % 2))
	    return new Double((list1[list1.length/2]+list1[list1.length/2-1])/2); 
	else
	    return new Double(list1[list1.length/2]);
    }	
	
    public static Object prim_listmean(Object v0, Context c) {
	Object[] list = YoYo.aList(c, v0);
	if (list.length == 0) {
	    LogoError.error(LogoError.CANTCOMPUTE + " " + LogoError.AVERAGE + " " +
			    LogoError.OFEMPTYLIST, c);
	    return null;
	}
	int count  = 0;
	for(int i =0; i < list.length; i++) {
	    if (list[i] instanceof Number) count++;
	}
	if (count == 0) {
	    LogoError.error(LogoError.CANTCOMPUTE + " " + LogoError.AVERAGE + " " +
			    LogoError.OFLIST + " " + YoYo.printToString(v0) + " " +
			    LogoError.HASNONUMBERS, c);
	}
	double[] list1 = new double[count];
	for (int i=0; i<list1.length; i++) {
	    if (list[i] instanceof Number) {
		list1[--count] = YoYo.aDoubleNoWarn(c, list[i]);
	    }
	}
	double sum = 0;
	for (int i=0; i<list1.length; i++)
	    sum += list1[i];
	return new Double(sum/list1.length);
    }
	
    public static Object prim_listvariance(Object v0, Context c) {
	return new Double(internal_listvariance(v0, false, c));
    }

    public static double internal_listvariance(Object v0, boolean sdevp, Context c) {
	Object[] list = YoYo.aList(c, v0);
	if (list.length == 0) {
	    LogoError.error(LogoError.CANTCOMPUTE + " " + 
			    ((sdevp) ? LogoError.SD : LogoError.VARIANCE) + " " +
			    LogoError.OFEMPTYLIST, c);
	    return 0.0; // stupid compiler
	}

	int count  = 0;
	for(int i =0; i < list.length; i++) {
	    if (list[i] instanceof Number) count++;
	}
	if (count == 0) {
	    LogoError.error(LogoError.CANTCOMPUTE + " " + 
			    ((sdevp) ? LogoError.SD : LogoError.VARIANCE) + " " +
			    LogoError.OFLIST + " " + YoYo.printToString(v0) + " " +
			    LogoError.HASNONUMBERS, c);
	}
	double[] list1 = new double[count];
	for (int i=0; i<list1.length; i++) {
	    if (list[i] instanceof Number) {
		list1[--count] = YoYo.aDoubleNoWarn(c, list[i]);
	    }
	}

	double sum = 0;
	for (int i=0; i<list1.length; i++) {
	    sum += list1[i];
	}
	double mean = sum / list1.length;
	sum = 0;
	for (int i=0; i<list1.length; i++) {
	    double val = list1[i]-mean;
	    sum += val * val;
	}
	return sum / list1.length;
    }
    
    public static Object prim_listsdev(Object v0, Context c) {
	double val = internal_listvariance(v0, false, c);
	return new Double(Math.sqrt(val));
    }

    public static Object prim_listsum(Object v0, Context c) {
	Object[] list = YoYo.aList(c, v0);

	int count  = 0;
	for(int i =0; i < list.length; i++) {
	    if (list[i] instanceof Number) count++;
	}
	if (count == 0) {
	    LogoError.error(LogoError.CANTCOMPUTE + " " + 
			    LogoError.SUM + " " +
			    LogoError.OFLIST + " " + YoYo.printToString(v0) + " " +
			    LogoError.HASNONUMBERS, c);
	}
	double sum = 0.0;
	for (int i=0; i<list.length; i++) {
	    if (list[i] instanceof Number) {
		sum += YoYo.aDoubleNoWarn(c, list[i]);
	    }
	}
	return new Double(sum);
    }	

    public static Object prim_listmode(Object v0, Context c) {
	Object[] list = YoYo.aList(c, v0);
	if (list.length == 0) {
	    LogoError.error(LogoError.CANTCOMPUTE + " " + LogoError.MODE + " " +
			    LogoError.OFEMPTYLIST, c);
	    return null;
	}

	int count  = 0;
	for(int i =0; i < list.length; i++) {
	    if (list[i] instanceof Number) count++;
	}
	if (count == 0) {
	    LogoError.error(LogoError.CANTCOMPUTE + " " + LogoError.MODE + " " +
			    LogoError.OFLIST + " " + YoYo.printToString(v0) + " " +
			    LogoError.HASNONUMBERS, c);
	}
	double[] numlist = new double[count];
	for (int i=0; i<numlist.length; i++) {
	    if (list[i] instanceof Number) {
		numlist[--count] = YoYo.aDoubleNoWarn(c, list[i]);
	    }
	}

	double currentelem = 0;
	Vector mode = new Vector(0,1);
	double modesize = 0;
	for (int j=0; j<numlist.length; j++) {
	    currentelem = numlist[j];
	    for (int i=0, currentsize=0; i<numlist.length; i++) {
		if (currentelem == numlist[i]) {
		    currentsize++;
		    if (currentsize == modesize) {
			Double potential = new Double(numlist[i]);
			if  (! (mode.contains(potential))) {mode.addElement(potential);}
		    }
		    if (currentsize>modesize) {
			modesize=currentsize; 
			mode=new Vector(); 
			mode.addElement(new Double(numlist[i]));
			
		    }
		    
		}
	    }
	}
	if (mode.size() == 1) {return mode.firstElement();}
	else {
	    Object[] result = new Object[mode.size()];
	    mode.copyInto(result);
	    return result;}
    }
	
    public static double[] mergesort(double[] dlist, int begin, int end) {
	if (begin == end)
	    return new double[] {dlist[begin]};
	int middle = (begin + end) / 2;
	double[] lista = mergesort(dlist, begin, middle);
	double[] listb = mergesort(dlist, middle+1, end);
	return merge(lista, listb);
    }
	
    private static double[] merge(double[] lista, double[] listb) {
	double[] listc = new double[lista.length+listb.length];
	int a=0,b=0;
	for (int i=0; i<listc.length; i++) {
	    if (a >= lista.length) {
		System.arraycopy(listb,b,listc,i,listb.length-b);
		break;
	    }
	    if (b >= listb.length) {
		System.arraycopy(lista,a,listc,i,lista.length-a);
		break;
	    }
	    if (lista[a] <= listb[b]) {
		listc[i] = lista[a++];
	    }	else {
		listc[i] = listb[b++];
	    }
	}
	return listc;
    }
	
    public static Object prim_copylist(Object v0, Context c)  {
	Object[] list = YoYo.aList(c, v0);
	Object[] copy = new Object[list.length];
	System.arraycopy(list, 0, copy, 0, copy.length);
	return copy;
    }
	
	
	
    public static Object prim_dolist(Object v0, Object v1, Context c)  {
		
	Object[] deflist = YoYo.aList(c, v0);
	Object[] torun = YoYo.aList(c, v1);
		
	Object oldvalue = null;
	LocalRef l;
	Object[] value;
	Symbol name;
		
	Object[] oldilist = c.ilist;
	int oldilistposptr = c.ilistposptr;
	try {
	    c.ilist = deflist;
	    c.ilistposptr = 0;
	    Object var = c.ilistNext();
	    if (var instanceof LocalRef) {
		l = (LocalRef)var;
		oldvalue = c.locals.lookupValue(l);
	    } 
	    else {
		name = YoYo.aSymbol(c, var);
		if (c.locals.boundp(name)) {
		    int index = c.locals.index(name);
		    l = new LocalRef(index, name);
		    c.setPrev(l);
		    oldvalue = c.locals.lookupValue(l);
		}
		else {
		    int index = c.locals.defineVar(name);
		    l = new LocalRef(index, name);
		    c.setPrev(l);
		    oldvalue = null;
		}
	    }
	    if (c.ufunobj != null) {
		if (c.locals.names.length > c.ufunobj.arglist.length) 
		    c.ufunobj.arglist = c.locals.names;
	    }
	    value = YoYo.aList(c, YoYo.evalOneFromHere(c));
	}
	finally {
	    c.ilist = oldilist;
	    c.ilistposptr = oldilistposptr;
	}
		
	try {
	    for (int i = 0; i < value.length; i++) {
		c.locals.setValue(l, value[i]);
		YoYo.evalList(torun, c);
		if (c.ufunreturn != null) return null;
	    }
	    return null;
	}
	finally {
	    if (oldvalue!=null) c.locals.setValue(l, oldvalue);
	    else c.locals.undefineVar(l);
	}
    }
	
    public static Object prim_to_list(Object v0, Context c)  {
		
	Object[] list = YoYo.aList(c, v0);
	Vector out = new Vector();
		
	Object[] oldilist = c.ilist;
	int oldilistposptr = c.ilistposptr;
	try {
	    c.ilist = list;
	    c.ilistposptr = 0;
	    while (true) {
		if (c.ilistPeek() == null) break;
		out.addElement(YoYo.evalOneFromHere(c));
	    }
	    Object[] output = new Object[out.size()];
	    out.copyInto(output);
	    return output;
	}
	finally {
	    c.ilist = oldilist;
	    c.ilistposptr = oldilistposptr;
	}
    }
	
    public static Object prim_replace(Object v0, Object v1, Object v2, Context c) {
	if (v2 instanceof Object[]) {
	    Object[] copy = new Object[((Object[])v2).length];
	    System.arraycopy((Object[])v2, 0, copy, 0, copy.length);
	    for(int i = 0; i< copy.length; i++) {
		if (YoYo.equal(v0, copy[i]) == YoYo.symtrue) copy[i] = v1;
	    }
	    return copy;
	}
	if (v2 instanceof String) {
	    String s1 = YoYo.aString(c, v0);
	    String s2 = YoYo.aString(c, v1);
	    return ((String)v2).replaceAll(s1, s2);
	}
	LogoError.error(YoYo.printToString(v0) + LogoError.NOT_LIST_OR_STRING, c);
	return null;
    }

    public static Object prim_reverse(Object v0, Context c) {
	if (v0 instanceof Object[]) {
	    Object[] list = (Object[])v0;
	    Object[] newlist = new Object[list.length];
	    for(int i = 0; i < list.length; i++) {
		newlist[list.length - i - 1] = list[i];
	    }
	    return newlist;
	}
	LogoError.error(YoYo.printToString(v0) + LogoError.NOT_LIST, c);
	return null;
    }
	
}


