/********************************************************************
OpenStarLogo

Originally developed by Mitchel Resnick, Andrew Begel, Eric Klopfer, Michael
Bolin, Corey McCaffrey, Molly Jones, Matthew Notowidigdo, Sebastian Ortiz, David
Greenspan, Michael Mandel, Tim Garnett, Max Goldman, Julie Kane, Russell
Zahniser, Weifang Sun, and Robert Tau at the MIT Teacher Education Program and
Media Laboratory, MIT, Cambridge, Massachusetts, with support from the National
Science Foundation and the LEGO Group. With previous work by Vanessa Colella,
Bill Thies, Brian Silverman, Monica Linden, Alice Yang, Ankur Mehta, Adam Eames,
Max Planck, and Sumita Kumar.

Copyright (c) 2006 MIT Teacher Education Program

Created by the MIT Teacher Education Program (http://education.mit.edu), and MIT
Media Lab (http://www.media.mit.edu) at the Massachusetts Institute of
Technology, Cambridge, MA. Permission is hereby granted, free of charge, to any
person obtaining a copy of this software and associated documentation files (the
"Software"), to deal in the Software without restriction, including without
limitation the rights to use, copy, modify, merge, publish, distribute,
sublicense, and/or sell copies of the Software, and to permit persons to whom
the Software is furnished to do so, subject to the following conditions:

1. The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software. 2. For rights to publish,
distribute, sublicense or sell the Software or its derivatives for commercial
purposes, please see the Technology Licensing Office, MIT, Five Cambridge
Center, Kendall Square Room NE25-230, Cambridge, MA 02142-1493, (617) 253-6966

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *******************************************************************/
 package yoyo;

import java.io.LineNumberReader;
import java.io.StringReader;
import java.io.IOException;

public class StringParser implements YoYoMethods {

  public static LineNumberReader s;
  
  public String[] methodList() {
    String[] out = {
      "set-line-string", "prim_setString",
      "read-line", "prim_readLine",
      "get-line-number", "prim_getLineNumber",
      "balanced?", "prim_balancedp"
    };
    return out;
  }

  public String[] infixList() {
    return null;
  }

    public void prePrimCall(Primitive p, Object[] arglist, Context c) {}
    public void postPrimCall(Primitive p, Context c) {}

  public static void prim_setString(Object v0, Context c) {
    s = new LineNumberReader(new StringReader(YoYo.aString(c, v0)));
  }

  public static Object prim_readLine(Context c) {
    try {
      String out = s.readLine();
      if (out == null) return YoYo.symfalse;
      return out;
    }
    catch (IOException e) { c.err.println("shoot"); }
    return null; // dumbass compiler
  }
  
  public static Object prim_getLineNumber(Context c) {
    return new Integer(s.getLineNumber());
  }

  public static Object prim_balancedp(Object v0, Object v1, Object v2, Context c) {
    String s = YoYo.aString(c, v0);
    String open = YoYo.aString(c, v1);
    String close = YoYo.aString(c, v2);
    Tokenizer t = new Tokenizer(s);
    return YoYo.truefalse(t.balancedp(open, close));
  }
  

}
